#include "gba.h"
#include "piohost.h"

u32 IntrMainBuf[0x200];

typedef void (*IntrFuncp)(void);
void IntrDummy(void);
void SioIntr(void);
u32  MidiKey2Freq(void *p1, u8 p2, u8 p3);

const IntrFuncp IntrTable[13] = {
    IntrDummy,      // Vblank
    IntrDummy,      // Hblank
    IntrDummy,      // Vcounter
    IntrDummy,      // timer0
    IntrDummy,      // timer1
    IntrDummy,      // timer2
    IntrDummy,      // timer3
    SioIntr,        // SIO
    IntrDummy,      // DMA0
    IntrDummy,      // DMA1
    IntrDummy,      // DMA2
    IntrDummy,      // DMA3
    IntrDummy,      // KEY
};

extern void intr_main(void);

void AgbMain(){
	s32 i,len;

    DmaCopy(3, intr_main, IntrMainBuf, sizeof(IntrMainBuf), 32);
    *(vu32 *)INTR_VECTOR_BUF = (vu32 )IntrMainBuf;
	pio_init();
    *(vu16 *)REG_IME   = 1;
    *(vu16 *)REG_IE    = SIO_INTR_FLAG;

	for (i=0; i<0x4000; i+=4){
		*((u8 *)0x02020000+i+0) = (MidiKey2Freq((void *)(i-3), 180-12, 0) * 2)>>24;
		*((u8 *)0x02020000+i+1) = (MidiKey2Freq((void *)(i-2), 180-12, 0) * 2)>>24;
		*((u8 *)0x02020000+i+2) = (MidiKey2Freq((void *)(i-1), 180-12, 0) * 2)>>24;
		*((u8 *)0x02020000+i+3) = (MidiKey2Freq((void *)(i-4), 180-12, 0) * 2)>>24;
	}
	i=PcOpen("bios.bin",PC_CREAT|PC_TRUNC|PC_WRONLY);
	len=PcWrite(i,(u8 *)0x02020000,0x4000);
	PcClose(i);
	PcPrintf("write 0x%x bytes.\n",len);
	for(;;);	//[v
}


void IntrDummy(void){
}
